/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */

#ifndef SBK_QGLCONTEXTWRAPPER_H
#define SBK_QGLCONTEXTWRAPPER_H

#define protected public

#include <shiboken.h>

#include <qgl.h>

class QGLContextWrapper : public QGLContext
{
public:
    QGLContextWrapper(const QGLFormat & format);
    virtual bool chooseContext(const QGLContext * shareContext = 0);
    virtual void * chooseVisual();
    virtual bool create(const QGLContext * shareContext = 0);
    virtual void doneCurrent();
    virtual void makeCurrent();
    virtual void swapBuffers() const;
    virtual void * tryVisual(const QGLFormat & f, int bufDepth = 1);
    virtual ~QGLContextWrapper();
    static void pysideInitQtMetaTypes();
};

#endif // SBK_QGLCONTEXTWRAPPER_H

